<template>
  <div>
    <h3 v-if="title" class="title">
      {{ title }}
    </h3>

    <b-form inline @submit.prevent="search">
      <label class="sr-only" :for="name">{{ placeholder }}</label>
      <b-input
        :id="name"
        v-model="input"
        class="mb-2 mr-sm-2 mb-sm-0"
        :placeholder="placeholder"
        name="sc-history-search"
      />
      <b-button type="submit" variant="primary">
        {{ $t('buttons.search') }}
      </b-button>
    </b-form>
  </div>
</template>

<script>
import { mapActions } from 'vuex'
import { slugify } from '@/lib/helpers'

export default {
  name: 'SearchForm',
  props: {
    title: {
      type: String,
      required: false,
      default: ''
    },
    placeholder: {
      type: String,
      required: false,
      default: ''
    },
    baseUrl: {
      type: String,
      required: true
    }
  },
  data () {
    return {
      input: ''
    }
  },
  computed: {
    name () {
      return slugify(this.placeholder)
    }
  },
  methods: {
    ...mapActions('player', ['getPlayer']),
    slugify,
    search () {
      this.getPlayer(this.input)
        .then(() => {
          this.$router.push(`${this.baseUrl}/${this.input}`)
        })
        .catch(() => {
          alert(`${this.$t('player.no_player')} ${this.input}`)
        })
    }
  }
}
</script>
